uses crt,dos;

{$M 10000,42000, 42000}	{heap must be cca 36000+30*maxlems}

const maxlems=200;
const lmWalker=1;
	  lmDigger=2;
	  lmBlocker=3;
	  lmUmbreller=4;	{pseudo type}
	  lmFlyer=5;
	  lmTunneller=6;
	  lmBuilder=7;


	  lmLAST=7;	{set this to the value of the largest lmXXXX constant!!!}


var progPath:string;
	rock:byte;
const imgInd:array[1..lmLAST] of byte=(0,6,11,5,32,15,24);
const
	  stair=2;
function getBMPPixel(bmp:pointer;x,y:word;w:word):byte;
var ss,oo,l,h:word;
	off:longint;
begin
	off:=longint(y)*w+x;
	ss:=seg(bmp^);
	oo:=ofs(bmp^);
	l:=off and $FFFF;
	h:=off shr 16;
	asm
		mov ax,&ss
		mov bx, oo
		xor cx,cx
		add bx, l
		adc cx, h

		shl cl,1
		shl cl,1
		shl cl,1
		shl cl,1

		add ah,cl
		mov &ss,ax
		mov oo,bx
	end;

	getBMPPixel:=mem[ss:oo];
end;

procedure setBMPPixel(bmp:pointer;x,y,w:word;b:byte);
var ss,oo,l,h:word;
	off:longint;
begin
	off:=longint(y)*w+x;
	ss:=seg(bmp^);
	oo:=ofs(bmp^);
	l:=off and $FFFF;
	h:=off shr 16;
	asm
		mov ax,&ss
		mov bx, oo
		xor cx,cx
		add bx, l
		adc cx, h

		shl cl,1
		shl cl,1
		shl cl,1
		shl cl,1

		add ah,cl
		mov &ss,ax
		mov oo,bx
	end;

	mem[ss:oo]:=b;
end;

type arr=array[0..$FFF0] of byte;
var lemImg, land: ^arr;
	deltax,deltay, scrwidth, scrheight, width, height, viewtop, viewleft, viewbottom, viewright, lemImgWidth:word;
	timer:longint;

{$I bmps.pas}
{$I tmouse.pas}
{$I lemtypes.pas}

function mini(a,b:integer):integer; begin mini:=(a+b-abs(a-b)) div 2; end;
function maxi(a,b:integer):integer; begin maxi:=(a+b+abs(a-b)) div 2; end;
function ltostr(a:longint):string;var s:string;begin str(a,s); ltostr:=s; end;
function strtoi(s:string):longint; var i:integer; ret:longint; begin val(s,ret,i);if i<>0 then ret:=0; strtoi:=ret;end;
(************************  TLemming  ****************************************)


constructor TLemming.init(xx,yy:word; xdir:shortint;lt:longint);
begin
	x:=xx;y:=yy;oldx:=x;oldy:=y;lifetime:=lt; dir:=xdir;
	phase:=0;
end;

destructor TLemming.done;
begin
sound(200);
delay(1);
nosound;

asm nop; end;
end;
{redraws the "land" bitmap in the original location"}
procedure TLemming.undraw;
var firstx,firsty,lastx,lasty:integer;
begin

	{We have to clip the image off when near the "viewport" border.
		first[x|y] is the first row/column of the image to be displayed;
		last[x|y] is the last one
	}
	firstx:=maxi(0,deltax-oldx);
	firsty:=maxi(0,deltay-oldy);
	lastx:=mini(16,16+(deltax+viewright-viewleft-16)-oldx);
	lasty:=mini(16,16+(deltay+viewbottom-viewtop-16)-oldy);

	{if there's still anything to draw, draw it}
	if (firstx<=15) and (lastx>0) and (firsty<=15) and (lasty>0) then
		showBMP(oldx+viewleft-deltax+firstx, oldy+viewtop-deltay+firsty, land,
			oldx+firstx, oldy+firsty, lastx-firstx, lasty-firsty,width, copyput);

end;

{draws the lemming on the screen}
procedure TLemming.draw;
var firstx,firsty,lastx,lasty:integer;
begin
	{Same as undraw. When lifetime is 0 the lemming is not drawn, because a dead lemming would not
	be undrawn in the next tick}
	firstx:=maxi(0,deltax-x);
	firsty:=maxi(0,deltay-y);
	lastx:=mini(16,16+(deltax+viewright-viewleft-16)-x);
	lasty:=mini(16,16+(deltay+viewbottom-viewtop-16)-y);
	if (firstx<=15) and (lastx>0) and (firsty<=15) and (lasty>0) and (lifeTime<>0) then
		showBMP(x+viewleft-deltax+firstx,y+viewtop-deltay+firsty, lemImg, (imgindex+phase)*16+firstx, 8-8*dir+firsty,
			lastx-firstx, lasty-firsty, lemImgWidth, transparentput);

end;

{when a lemming dies, it can either reincarnate into another lemming (=new pointer), or
die permanently(=nil)}
function TLemming.reincarnate:PLemming;
begin
	reincarnate:=nil;
end;
function Tlemming.tick:PLemming;
begin
	oldx:=x;
	oldy:=y;
	dec(lifeTime);
	if lifeTime=-1 then begin
		tick:=reincarnate;
	end
	else tick:=@self;
end;

{testSpace tests if the lemming can go to a certain spot by "ANDing" the lemming bitmap
 against the "land" bitmap.}
function TLemming.testSpace(xx,yy:integer):boolean;

var lando,lands,lemo,lems, lemdelta, landdelta:word;
	ret:byte;
label l1,l2,l3, l4,no_way,ok;

begin



	lems:=seg(lemimg^);
	lemo:=ofs(lemimg^)+(imgindex+phase)*16+(8-8*dir)*lemImgWidth;

	lands:=seg(land^)+(yy*width+xx) shr 4;
	lando:=ofs(land^)+(yy*width+xx) and 15;

	lemdelta:=lemImgWidth-16;
	landdelta:=width-16;

	ret:=0;

	if (xx>=0) and (xx<=width-16) and (yy>=0) and (yy<=height-16) then
		asm
			push ds
			push es


			mov bx, lems
			push bx
			pop es
			mov di, lemo
			{es:di = address of the lemming image}

			mov dx, lands
			push dx
			pop ds
			mov si, lando
			{ds:si = address of the land image}

			cld
			mov cx,16	{for cx:=1 to 16}
			l1:
				push cx
				mov cx,16	{for cx:=1 to 16}
				l2:
					lodsb      	{al=one of the bytes to test}
					cmp si,0	{test for segment boundary}
					jne l3
						push ds
						pop bx
						inc bx
						push bx
						pop ds
					l3:

					mov ah,es:[di]
					cmp ah,0
					je ok
						cmp al, 0	{do the test}
						jne no_way			{one non_zero is enough to stop the poor lemming}
					ok:
					inc di
					cmp di,0            {inc di and test for seg. boundary}
					jne l4
						push es
						pop bx
						inc bx
						push bx
						pop es
					l4:
				loop l2		{inner for}
				pop cx


				push ds		{we need access to local vars}
				pop bx		{... so store the ds to bx}
				pop ds		{restore the original ds}

				push es		{move to the next line in both land and lemimg}
				pop ax
				add di,lemdelta
				adc ax,0
				push ax
				pop es

				add si, landdelta
				adc bx,0
				push ds		{ok, put the original ds back on the stack}
				push bx
				pop ds		{and make ds point to the bitmap again}
			loop l1	{outer for}

			pop ds
			mov ret,1
			push ds

			push cx {the jnz no_way bypassed a "pop cx"}
		no_way:
			pop cx

			pop es
			pop ds


		end;
	testspace:=boolean(ret);
end;



(*********************** TWalker ********************************************)
constructor TWalker.init(xx,yy:word; xdir:shortint;lt:longint);
begin
	umbreller:=false;
	fallCount:=0;
	imgindex:=imgInd[lmWalker];
	phaseinc:=-1;
	TLemming.init(xx,yy,xdir,lt);

end;


function TWalker.tick:PLemming;
var	straightDown:boolean;
begin
	tick:=TLemming.tick;

	{try to continue in the same direction, going as much "down" as possible"}
	straightDown:=false;
	if testSpace(x,y+2) then begin y:=y+2; straightDown:=true; end
	else if testSpace(x,y+2) then begin y:=y+2; end
	else if testSpace(x+2*dir,y+2) then begin y:=y+2; x:=x+2*dir; end
	else if testSpace(x+2*dir,y+1) then begin y:=y+1; x:=x+2*dir; end
	else if testSpace(x+2*dir,y+0) then begin y:=y+0; x:=x+2*dir; end
	else if testSpace(x+2*dir,y-1) then begin y:=y-1; x:=x+2*dir; end
	else if testSpace(x+2*dir,y-2) then begin y:=y-2; x:=x+2*dir; end
	else dir:=-dir;	{Well, you'll have to turn round, Lemming!}

	if umbreller then fallcount:=0;

	if straightDown then
		if umbreller then phase:=5
		else inc(fallCount)

	else begin
		if phase=5 then begin phase:=0; phaseInc:=-1; end;
		if fallCount>15 then lifeTime:=0 else fallCount:=0;
		if (phase=0) or (phase=4) then phaseinc:=-phaseinc;
		phase:=(phase+phaseinc) mod 5;
	end;


end;

{make sure the lemming does not go to a place, where it cannot turn round}
function TWalker.testSpace(xx,yy:integer):boolean;
var ret:boolean;
begin
	ret:=TLemming.testSpace(xx,yy);
	dir:=-dir;
	ret:=ret and TLemming.testSpace(xx,yy);
	dir:=-dir;
	testspace:=ret;

end;

(*********************** TDigger ********************************************)
constructor TDigger.init(xx,yy:word; xdir:shortint;lt:longint);
var i,j:integer;
begin
	emptyCount:=0;
	imgindex:=imgInd[lmDigger];
	TLemming.init(xx,yy,xdir,lt);
	{this will ensure that no pixels are left in the new schaft}
	for i:=1 to 15 do
		for j:=8 to 15 do
			setBMPPixel(land,x+i,y+j,width,0);

end;

function TDigger.tick:PLemming;
var i,pix:byte;
	ok, empty:boolean;
	yy:word;
begin
	tick:=TLemming.tick;

	if (y>=height-16) then lifeTime:=0
	else begin
		if phase=0 then begin
			ok:=true;
			empty:=true;
			for i:=1 to 15 do begin
				yy:=y+15;
				if (i>3) and (i<12) then inc(yy);
				pix:=getBMPPixel(land,x+i,yy,width);
				if pix=rock then ok:=false
					else setBMPPixel(land,x+i,yy,width,0);
				if pix>0 then empty:=false;

			end;


			if (empty) then inc(emptyCount) else emptyCount:=0;
			if (not ok) or (emptyCount>1) then lifeTime:=0
			else inc(y);
		end;
	end;

	phase:=(phase+1) mod 5;
end;

function TDigger.reincarnate:PLemming;
begin
	reincarnate:=new(PWalker,init(x,y,dir,-1));
end;

(*********************** TBlocker ********************************************)

constructor TBlocker.init(xx,yy:word; xdir:shortint;lt:longint);
begin
	imgindex:=imgInd[lmBlocker];
	TLemming.init(xx,yy,xdir,lt);
	i:=0;
end;

destructor TBlocker.done;
begin
	TLemming.done;
	setBMPPixel(land,x+1,y+6,width,0);
	setBMPPixel(land,x+14,y+6,width,0);
end;
function TBlocker.tick:PLemming;
begin
	{this puts two rock-color dots to the bitmap, acting like a barrier for other
	lemmings, even all the diggers!.This would really belong to the constructor,
	but would not work when a Blocker reincarnates to a Blocker again}
	setBMPPixel(land,x+1,y+6,width,rock);
	setBMPPixel(land,x+14,y+6,width,rock);

	tick:=TLemming.tick;
	inc (i);
	if (i>2) then begin
		phase:=(phase+1) mod 4;
		i:=0;
	end;

end;

function TBlocker.reincarnate:PLemming;
begin
	reincarnate:=new(PWalker,init(x,y,dir,-2));
end;

(*********************** TTunneller ********************************************)
constructor TTunneller.init(xx,yy:word; xdir:shortint;lt:longint);
var i,j:integer;
begin
	emptyCount:=-15;
	imgindex:=imgInd[lmTunneller];
	TLemming.init(xx,yy,xdir,lt);
	{this will ensure that no pixels are left in the new tunnel}
	for i:=2 to 15 do
		for j:=0 to 15 do
			setBMPPixel(land,x+i,y+j,width,0);

end;

function TTunneller.tick:PLemming;
var i,pix:byte;
	ok, empty:boolean;
	xx:word;
begin
	tick:=TLemming.tick;

	if (x>=width-17) or (x<=1) then lifeTime:=0
	else begin
		if phase and 1 =0 then begin
			ok:=true;
			empty:=true;
			for i:=0 to 15 do begin
				xx:=7;
				if (i>3) and (i<12) then inc(xx);
				xx:=x+8+dir*xx;
				pix:=getBMPPixel(land,xx,y+i,width);
				if pix=rock then ok:=false
					else setBMPPixel(land,xx,y+i,width,0);
				if pix>0 then empty:=false;

			end;


			if (empty) then inc(emptyCount) else emptyCount:=0;
			if (not ok) or (emptyCount>1) or
				{test if the lemming can fall down}
				testSpace(x,y+1)
					then lifeTime:=0
			else inc(x,dir);
		end;
	end;

	phase:=(phase+1) mod 9;
end;

function TTunneller.reincarnate:PLemming;
begin
	reincarnate:=new(PWalker,init(x,y,dir,-1));
end;

(*********************** TBuilder  *********************************************)
constructor TBuilder.init(xx,yy:word; xdir:shortint;lt:longint);
begin
	imgindex:=imgInd[lmBuilder];
	TLemming.init(xx,yy,xdir,lt);
end;

destructor TBuilder.done;
begin
	TLemming.done;
end;
function TBuilder.tick:PLemming;
var i:integer;
begin
	tick:=TLemming.tick;
	if phase=3 then begin
			for i:=1 to 5 do begin
			setBMPPixel(land,x+i+5+5*dir,y+14,width,stair);
			setBMPPixel(land,x+i+5+5*dir,y+15,width,stair);
		end;
	end;
	if phase=4 then

		if testSpace(x+5*dir,y-2) then begin x:=x+5*dir; y:=y-2; end
			else tick:=new(PWalker,init(x,y,-dir,-2));


	phase:=(phase+1) mod 8
end;

function TBuilder.reincarnate:PLemming;
begin
	reincarnate:=new(PWalker,init(x,y,-dir,-2));
end;

(*********************** TFlyer ********************************************)
constructor TFlyer.init(xx,yy:word; xdir:shortint;lt:longint);
begin
	imgindex:=imgInd[lmFlyer];
	TLemming.init(xx,yy,xdir,lt);

end;


function TFlyer.tick:PLemming;
begin
	tick:=TLemming.tick;

	if testSpace(x+dir,y-1) then begin y:=y-1; x:=x+dir end
	else if testSpace(x-dir,y-1) then dir:=-dir
	else lifetime:=0;

	phase:=(phase+1) mod 4;
end;

function TFlyer.reincarnate:PLemming;
begin
	reincarnate:=new(PWalker,init(x,y,dir,-2));
end;
destructor TFlyer.done;
begin
	TLemming.done;
end;


(*****************************************************************************
******************************************************************************
*****************************************************************************)

function game(name:string):string;


var
	hdr:TBITMAPINFOHEADER;
	i,j,calib, calibCounter,
	lemsDead,lemTotal,lemsOut, lemsIn, lemsCount, lemInInterval, inX, inY, inDir, inTimeToLive,outx,outy, lemsToSave:integer;
	w,w1,w2,w3:word;
	mouse:Tmouse;
	redraw:boolean;
	s,s1,s2:string;
	b, menusel,speed:byte;
	tickCount,lastPass, lastLemIn, passTime,long1,long2:longint;
	t:text;
	lem:array[0..maxlems] of PLemming;
	ltmp:PLemming;
	font:pointer;
	noOf:array[1..lmLast] of word;


	label l1,l2,l3;


	{free up all the allocated memory}
	procedure cleanup;
		var i:integer;
	begin
		if lemimg<> nil then dispose(lemimg);
		if font <> nil then dispose(font);
		for i:=0 to lemsCount-1 do if lem[i]<>nil then dispose(lem[i]);
		if land<>nil then begin
			w:=seg(land^);
			asm
				mov ah,49h
				mov bx, w
				push bx
				pop es
				int 21h
			end;
		end;
	end;

	procedure drawStr(x,y:word;s:string;mode:byte);
	var i,ch:byte;
	begin
		for i:=1 to length(s) do begin
			ch:=ord(upcase(s[i]));
			if (ch<=ord('Z')) and (ch>=ord('0')) then
				showBMP(x+5*(i-1),y,font,(ch-ord('0'))*4,0,4,5,4*(ord('Z')-ord('0')+1), mode);
		end;
	end;

	procedure drawInfo;
	var x,y:word; b:byte;
	begin
		b:=2;
		for y:=1 to 25 do
			for x:=scrWidth-25 to scrwidth-1 do showBMP(x,scrheight-y,@b,0,0,1,1,1,copyput);

		drawStr(scrwidth-50, scrheight-23, 'In:  '+ltostr(lemsIn),transparentput);
		drawStr(scrwidth-50, scrheight-15, 'Out: '+ltostr(lemsOut),transparentput);
		drawStr(scrwidth-50, scrheight-7, 'Dead:'+ltostr(lemsDead),transparentput);


		for y:=1 to 25 do
			for x:=scrWidth-80 to scrwidth-55 do showBMP(x,scrheight-y,@b,0,0,1,1,1,copyput);

		drawStr(scrwidth-105, scrheight-23,  'Time:'+ltostr(round(timer*0.055)),transparentput);
		drawStr(scrwidth-105, scrheight-15, 'Save:'+ltostr(lemsToSave),transparentput);
		drawStr(scrwidth-105, scrheight-7, 'total'+ltostr(lemTotal),transparentput);
	end;
	procedure drawmenu;
	var x,y:word;
		b:byte;
		s:string[4];
	begin
		b:=2;
		for y:=1 to 25 do
			for x:=0 to scrwidth-1 do showBMP(x,scrheight-y,@b,0,0,1,1,1,copyput);

		x:=0;y:=scrheight-17;

		for x:=1 to lmLast do begin

		   if (x<>menusel) then b:=transparentput else b:=copyput;
		   showBMP((x-1)*16+1,y,lemimg,imgInd[x]*16,0,16,16,lemImgWidth,b);
		   str(noOf[x] mod 100:2,s); if s[1]=' ' then s[1]:='0';s[0]:=#2;
		   drawStr((x-1)*16+5,y-6,s,transparentput);
		end;

		inc(x,2);
		drawStr(x*16,scrheight-18,'SPEEED',transparentput);
		str(speed:2,s);if s[1]=' ' then s[1]:='0';s[0]:=#2;
		drawStr(x*16,scrheight-11,'< '+s+' >',transparentput);


		drawInfo;
	end;

	procedure menuClick;
	begin
		{lemming proffesions}
		if (mouse.lcx-1) div 16 < lmLast then menuSel:=(mouse.lcx-1) div 16 +1
		{speed +-}
		else if (abs(mouse.x-((lmLAST+2)*16))<10) and (speed>1) then dec(speed)
		else if (abs(mouse.x-((lmLAST+2)*16+6*4))<10) and (speed<20) then inc(speed)
		;

		passTime:=(20-speed);

		mouse.hide;
		drawMenu;
		mouse.show;
	end;



begin
	lemimg:=nil;
	font:=nil;
	land:=nil;
{first load the lemming images}
	if getBMPinfo(progPath+'lemimg.bmp',hdr)=0 	then begin game:='Cannot open lemimg.bmp'; cleanup; exit;; end;

	getmem(lemimg,hdr.width*hdr.height*2);
	if lemimg=NIL then begin game:='Out of heap'; cleanup; exit;; end;

	if loadBMP(progPath+'lemimg.bmp',lemimg)=0 then begin game:='Cannot open lemimg.bmp'; cleanup; exit;; end;

	lemImgWidth:=hdr.width;	{a commonly used global variable}

	{the lemimg.bmp contains a vertical 2-pixel line after each img. this will remove it}
	for i:=0 to 15 do
		for j:=0 to (16*lemImgWidth) div 18 do
				lemImg^[j+i*lemImgwidth]:=lemImg^[j+i*lemImgwidth+2*(j div 16)];

	{create a "horizontally flipped" copy of all the images}
	for i:=0 to 15 do
		for j:=0 to lemImgWidth do
				lemImg^[j+(i+16)*lemImgwidth]:=lemImg^[j+15-2*(j mod 16)+i*lemImgWidth];


{load the font}
	if getBMPinfo(progPath+'font.bmp',hdr)=0 	then begin game:='Cannot open font.bmp'; cleanup; exit;; end;

	getmem(font,hdr.width*hdr.height*2);
	if font=NIL then begin game:='Out of heap'; cleanup; exit;; end;
	if loadBMP(progPath+'font.bmp',font)=0 then begin game:='Cannot open font.bmp'; cleanup; exit;; end;


	for i:=1 to lmLAST do noOf[i]:=0;
	speed:=10;
	lemInInterval:=20;

{read and parse the lmg file}
	{$I-}
	assign(t, name+'.lmg');
	reset(t);
	while not eof(t) do begin
		readln(t,s1);
		for b:=1 to length(s1) do s1[b]:=upcase(s1[b]);
		b:=pos('=',s1);

		if b<>0 then begin
			s2:=copy(s1,b+1, length(s1)-b);
			s1[0]:=chr(b-1);
			while s1[length(s1)]=' ' do s1[0]:=chr(length(s1)-1);
			while s2[length(s2)]=' ' do s2[0]:=chr(length(s2)-1);
			{s1 is the variable name and s2 is the value}
			if      s1='LANDSCAPE' then s:=s2
			else if s1='LEMMINGS' then lemTotal:=strtoi(s2)
			else if s1='INTERVAL' then lemInInterval:=strtoi(s2)
			else if s1='SPEED' then speed:=strtoi(s2)

			else if s1='ENTRANCE X' then inX:=strtoi(s2)
			else if s1='ENTRANCE Y' then inY:=strtoi(s2)

			else if s1='EXIT X' then outX:=strtoi(s2)
			else if s1='EXIT Y' then outY:=strtoi(s2)

			else if s1='TO SAVE' then lemsToSave:=strtoi(s2)

			else if s1='WALKER' then noOf[lmWalker]:=strtoi(s2)
			else if s1='DIGGER' then noOf[lmDigger]:=strtoi(s2)
			else if s1='BLOCKER' then noOf[lmBlocker]:=strtoi(s2)
			else if s1='UMBRELLER' then noOf[lmUmbreller]:=strtoi(s2)
			else if s1='FLYER' then noOf[lmFlyer]:=strtoi(s2)
			else if s1='TUNNELLER' then noOf[lmTunneller]:=strtoi(s2)
			else if s1='BUILDER' then noOf[lmBuilder]:=strtoi(s2)




		end;
	end;
	close(t);
	if IOResult<>0 then begin game:='Cannot read '+name+'.lmg'; cleanup; exit;;end;

{now, load the lanscape and swith to graphics}
	if getBMPinfo(s,hdr)=0 then begin game:='Cannot open '+s; cleanup; exit;; end;

	width:=hdr.width;		{store the dims. in global variables}
	height:=hdr.height;

	{calculate the size of the bitmap an allocate memory}
	w2:=longint(width)*height div 16 + 1;
	asm
		mov ah,48h
		mov bx,w2
		int 21h
		mov w1,bx

		jnc l1
			mov ax,0
		l1:
		mov w,ax
	end;

	if w=0 then begin
		game:='Not enough memory: '+ltostr(longint(w2)*16)+' bytes needed; '+ltostr( longint(w1)*16)+ ' is available';
		cleanup; exit;;
		end;

	land:=ptr(w,0);

	{switch to graphics}
	asm
		mov ah,0
		mov al,13h
		int 10h
	end;
	scrwidth:=320;
	scrheight:=200;
	{all that needs to be modified for other screen modes is the above section and the showBMP() function}


	deltax:=0;	{horizontal scroll displacement}
	deltay:=0;  {vertical ...}

	{the drawing region}
	viewleft:=maxi(0,integer(scrwidth-width) div 2 );
	viewtop:=maxi(0,integer(scrheight-hdr.height-25) div 2);
	viewbottom:=scrheight-1-viewtop-25;
	viewright:=scrwidth-1-viewleft;

	if (loadBMPPal(s)=0)	{load the land pallette}

	or (loadBMP(s,land)=0) then begin game:='Cannot open '+s; cleanup; exit;; end;

	rock:=getBMPPixel(land,0,0,1);
{now, check the game parameters from the associated .lmg file and setup
 essential variables}


	lemsCount:=0;
	lemsOut:=0;
	lemsIn:=0;

	if lemTotal>maxLems then begin game:='The maximum number of lemmings is '+ltostr(maxLems); cleanup; exit;; end;
	if (speed<1) or (speed>20) then begin game:='SPEED must be between 1 and 20'; cleanup; exit; end;
	passTime:=(20-speed);

	inX:=inX-8; inY:=inY-8; outX:=outX-8; outY:=outY-8;
	if (inX<16) or (inX>width-16) or (inY<0) or (inY>height-16)
		then begin game:='ENTRANCE is outside the landscape or too near its edges.'; cleanup; exit; end;

{mouse initialization}
	if not mouse.test then begin game:='Mouse driver not present or not working properly.'; cleanup; exit;; end;
	mouse.maxx:=scrwidth;
	mouse.maxy:=scrheight;



	redraw:=true;	{this will ensure that the landscape will be drawn}

	tickCount:=0;	{tickCount will count all the ticks since start of the game}
	lastPass:=0;	{last pass through the loop}
	lastLemIn:=0;	{when tickCount>lastLemIn+lemInInterval a new lemming can be born}
	timer:=0;
	menusel:=1;
	calibCounter:=0;
	calib:=0;
	lemsDead:=0;

	drawMenu;
	mouse.show;

	(************************ MAIN LOOOOOOOOOP *************************)
	while (lemsOut<lemsToSave) and (port[$60]<>1) and (port[$60]<>129)do begin
		inc(tickCount);

		{should a new lemming be born?}
		if	(tickCount>lastLemIn+lemInInterval) and (lemsIn<lemTotal) then begin
			{ok, create a new TWalker}

			{i is a random direction}
			if random(2)=0 then i:=1 else i:=-1;

			lem[lemsCount]:=new(PWalker, init(inX,inY, i, -2));
			if lem[lemsCount]=NIL then begin game:='Out of heap'; cleanup; exit;; end;

			lastLemIn:=tickCount {next lemming in lemInInterval ticks};
			inc(lemsCount);	{one more lemming in the array}
			inc(lemsIn);	{one more lemming has been born}
		end;


		mouse.update;	{gets new mouse pos, status, etc.}

		{scrolling - if the mouse pointer is moved to the sides of the drawing area, scroll!}
		if mouse.right then for i:=1 to 10 do begin
			if (mouse.x>=viewright-10) and (deltax<width-(viewright-viewleft)) then begin
				inc(deltax);
				redraw:=true;
			end;
			if (mouse.x<=viewleft+10) and (deltax>0) then begin
				dec(deltax);
				redraw:=true;
			end;
			if (mouse.y>=viewbottom-10) and (deltay<height-(viewbottom-viewtop)) then begin
				inc(deltay);
				redraw:=true;
			end;
			if (mouse.y<=viewtop+10) and (deltay>0) then begin
				dec(deltay);
				redraw:=true;
			end;
		end;

		{left click  handling}
		if mouse.lclicks>0 then begin
			if mouse.lcy>scrheight-25 then menuClick	{if the click occured in the menu area, let the menu process it}
			else begin
				{find the nearest lemming (j)}
				long2:=maxLongInt;
				for i:=0 to lemsCount-1 do begin
					long1:=sqr(longint(mouse.lcx-viewleft-lem[i]^.x-8+deltax))+sqr(longint(mouse.lcy-viewtop-lem[i]^.y-8+deltay));
					if long1<long2 then begin
						long2:=long1;
						j:=i;
					end;
				end;
				{only do the following if the click was near-enough to the closest lemming
					also, make sure the required proffesion is still available}
				if (long2<64) and (noOf[menuSel]>0) then begin
					ltmp:=lem[j];	{save the orig. pointer for dispose()}
					dec(noOf[menuSel]);
					case menuSel of
						lmWalker:begin
								lem[j]:=new(PWalker,init(ltmp^.x,ltmp^.y,ltmp^.dir,-2));
								dispose (ltmp,done);
								end;
						lmDigger: begin
								lem[j]:=new(PDigger,init(ltmp^.x,ltmp^.y,ltmp^.dir,200));
								dispose (ltmp,done);
								end;
						lmBlocker: begin
								lem[j]:=new(PBlocker,init(ltmp^.x,ltmp^.y,ltmp^.dir,-2));
								dispose (ltmp,done);
								end;
						lmUmbreller: lem[j]^.umbreller:=true;
						lmFlyer: begin
								lem[j]:=new(PFlyer,init(ltmp^.x,ltmp^.y,ltmp^.dir,200));
								dispose (ltmp,done);
								end;
						lmTunneller: begin
								lem[j]:=new(PTunneller,init(ltmp^.x,ltmp^.y,ltmp^.dir,120));
								dispose (ltmp,done);
								end;
						lmBuilder: begin
								lem[j]:=new(PBuilder,init(ltmp^.x,ltmp^.y,ltmp^.dir,100));
								dispose (ltmp,done);
								end;
					end;


					drawMenu;	{because the number of available lemmings has been decreased}
				end;
			end;
		end;

		{TICK'em ALL!}
		i:=0;
		while i<lemsCount do begin
			ltmp:=lem[i];

			lem[i]:=lem[i]^.tick;
			if lem[i]<>ltmp then begin
			   if lem[i]=nil then begin	{if the i'th lemming just died...}
				   lem[i]:=lem[lemsCount-1]; {rearrange the array}
				   dec(lemsCount);
				   inc(lemsDead);
			   end;
			   dispose(ltmp,done);
			end else begin
				if (abs(lem[i]^.x-outX)<8) and (abs(lem[i]^.y-outY)<8) then begin
					inc(lemsOut);
					dec(lemsDead);
					lem[i]^.lifetime:=0;
				end;
				inc(i);
			end;
		end;

		mouse.hide;	{the mouse cursor has to be hidden before any drawing}

		{redraw the landscape if necessary (e.g. after a scroll, first tick, etc.}
		if redraw then begin
			showBMP(viewleft,viewtop,land,deltax,deltay,viewright-viewleft,viewbottom-viewtop,width,copyput);
			redraw:=false;
		end;

		{first "undraw" the lemmings - clear them off the screen}
		for i:=0 to lemsCount-1 do
			lem[i]^.undraw;

		{draw all the lemmings}
		for i:=0 to lemsCount-1 do
			lem[i]^.draw;
		if (timer and 3)=0 then drawInfo;


		mouse.show;	{show mouse after drawing}


		{becouse the system clock is not fine enough, we have to adjust the speed
		using e.g. delay(); This is to calibrate the delay()'s parameter according
		to the current computer and game speed.}

		if (calibCounter mod 4)=0 then begin   {calibrate every four ticks}

			i:=(lastPass+passTime-timer);
			if abs(i)>2 then i:=i*5;  {if the difference is large, calibrate faster}
			calib:=calib+i; {increase calib, if too fast, decrease if too slow}
			lastPass:=timer;         	{for next calibration}
			if calib<0 then calib:=0;   {dealy() would hang if calib was <0}
		end;
		inc(calibCounter);

		if calib>0 then delay(calib);
	end;
	inc(lemsdead);
	drawInfo;

	readkey;
	if lemsOut>=lemsToSave then game:=ltostr(round(timer*0.055)) else game:='You have ESCaped';
	cleanup;
end;

(*****************************************************************************
******************************************************************************
*****************************************************************************)


{timehandler is an interrupt handler, that will increase the timer variable
each tick of the system clock}
procedure timerhandler;interrupt; begin	inc(timer); end;





type PList=^TList;
	TList=record
		item:SearchRec;
		next:PList;
	end;
(****************************************************************************)
var oldtimerseg, oldtimerofs:word;
	i,dispHeight,oldScrMode:byte;
	listLen, cursPos, listDelta:word;
	list, list1,list2:PList;
	listend:^PList;
	ch:char;
	s:string;
	tmp:SearchRec;
	chgdrive:boolean;
begin

{initialize the timer interrupt handler, save old int. vectors}
	oldtimerseg:=memw [0:$1c*4+2];
	oldtimerofs:=memw [0:$1c*4];
	memw [0:$1c*4+2]:=seg(timerhandler);
	memw [0:$1c*4]:=ofs(timerhandler);
{save  the screen mode}
	asm
		mov ah,0fh
		int 10h
		mov oldScrMode,al
	end;

	getDir(0,progPath); {save the program path}
	if progPath[length(progPath)]<>'\' then progPath:=progPath+'\';

{start the intro}
	s:=game('intro');
	if strtoi(s)<>0 then s:='Enjoy this game!';

repeat {an infinite "select-game"-"game" cycle}
	asm		{normal text mode, no cursor}
		mov ah,0
		mov al,3
		int 10h
		mov ah,1
		mov ch,20h
		mov cl,0
		int 10h
	end;

	{right window}
	window(30,1,80,25);
	textbackground(blue);
	clrscr;
	textcolor(red);
	writeln(' '+s);
	textcolor(yellow);
	gotoxy(1,20);
	writeln(' Select a game with <ENTER> or press <ESC> to exit.');
	writeln(' Press <D> to change the current drive.');

	{left window}
	window(1,1,28,25);
	chgDrive:= false;	{true when the user presses 'D')}

	repeat	{repeat until a file is selected}

		{build a linked list used with all the files+dirs or all the drives a-z}
		listEnd:=@list;
		listLen:=0;

		if chgdrive then begin {select a new drive}
			for i:=ord('A') to ord('Z') do begin
				tmp.name:=chr(i)+':';
				tmp.attr:=255;
				listEnd^:=new (PList);
				listEnd^^.item:=tmp;
				listEnd:=@(listEnd^^.next);
				inc(listLen);

			end;
			chgdrive:=false;	{next time, normal dir listing}
		end
		else begin
		{all the directories}
			{first, add the ".." directory, because findfirst is really weird
			and returns that directory according to the current wid direction}

			tmp.name:='..';
			tmp.attr:=directory;
			listEnd^:=new (PList);
			listEnd^^.item:=tmp;
			listEnd:=@(listEnd^^.next);
			inc(listLen);

			FindFirst ('*.*', anyfile,tmp);
			while dosError=0 do begin
				if ((tmp.attr and directory)>0) and (tmp.name[1]<>'.') then begin {must be dir}
					{only dirs, not '.' and '..' (in case findfirst decided to return it :-)}
					listEnd^:=new (PList);
					listEnd^^.item:=tmp;
					listEnd:=@(listEnd^^.next);
					inc(listLen);
				end;
				findnext(tmp);
			end;

			{all the files}
			FindFirst ('*.lmg', archive,tmp);
			while dosError=0 do begin
				listEnd^:=new(PList);
				listEnd^^.item:=tmp;
				listEnd:=@(listEnd^^.next);
				inc(listLen);
				findNext(tmp);
			end;
		end;

		listEnd^:=nil;

		curspos:=ioresult;	{just read ioresult}
		cursPos:=0;
		listDelta:=0;
		dispHeight:=20;
		if dispHeight>listLen then dispHeight:=listLen;

		repeat	{a simple listbox, until <ENTER> <D> or <ESC> is pressed}

			textbackground(black);
			textcolor(yellow);
			clrscr;
			list1:=list;
			for i:=1 to listDelta do list1:=list1^.next; {move on to the first line to be displaid}
			for i:=0 to dispHeight-1 do begin	{for all the lines on-screen}
				if i=curspos then TextBackground(red) else textBackGround(blue);
				tmp:=list1^.item;

				s:=tmp.name;
				while length(s)<16 do s:=s+' ';		{right pad with ' '}
				if tmp.attr=255 then s:=s+'<DISK>'
					else if (tmp.attr and directory)<>0 then s:=s+'<DIR> '
						else s:=s+'      ';
				writeln(s);
				list1:=list1^.next;
			end;
			{write the current dir. at the bottom}
			getDir(0,s);
			textbackground (0);
			writeln;
			writeln(s);

			ch:=readkey;
			if ch=#0 then ch:=readkey;
			case ch of
				{down}
				#80: begin
						if cursPos<dispHeight-1 then inc(cursPos)
						else if (listDelta+dispHeight<listLen) then inc(listDelta);
					end;
				{up}
				#72: begin
						if cursPos>0 then dec(cursPos)
						else if listDelta>0 then dec(listDelta);
					end;
				'd','D':chgDrive:=true;
			end;
		until not ((ch<>#13) and (ch<>#27) and (upcase(ch)<>'D'));

		list1:=list;

		{find the selected item}
		for i:=1 to listDelta+cursPos do list1:=list1^.next;

		tmp:=list1^.item; {save the selected item}

		{deallocate the list}
		while list<>nil do begin
			list1:=list;
			list:=list^.next;
			dispose(list1);
		end;

		{if a directory is selected, chdir}

		if (tmp.attr and directory) <> 0 then chdir(tmp.name)
		else tmp.attr:=0;
		if chgdrive then tmp.attr:=directory;
	until (tmp.attr=0) or (ch=#27); {until a file is selected}

	textbackground(black);

	{Is the user fed up??? why??}
	if ch=#27 then begin	{<ESC>? -> exit}
		{restore the original INT 1CH vector and screen mode}
			memw [0:$1c*4+2]:=oldtimerseg;
			memw [0:$1c*4]:=oldtimerofs;
			asm
				mov ah,0
				mov al, oldScrMode;
				int 10h
			end;
			chdir(progPath);
			writeln('Thank you for playing!');
			halt(1);
	end;

	tmp.name[0]:=chr(ord(tmp.name[0])-4); {cut-off the extension}

	s:=game(tmp.name);	{PLAY!!}
	{if the game finished ok, s is the # of seconds elapsed}
	if strtoi(s)<>0 then s:='You managed to save enough lemmings in '+s+#10#13+' seconds; Congratulations!';

until false;
end.