type PLemming=^TLemming;
	 TLemming=object

		x,y,oldx, oldy:integer;
		lifetime:longint;
		imgindex, phase:byte;
		dir:shortint;
		climber, umbreller:boolean;

		constructor init(xx,yy:word; xdir:shortint; lt:longint);
		destructor done;virtual;

		function tick:PLemming; virtual;
		procedure draw; virtual;
		procedure undraw; virtual;
		function testSpace(xx,yy:integer):boolean;virtual;
		function reincarnate:PLemming;virtual;

	end;


type PWalker=^TWalker;
	TWalker=object(TLemming)
		fallCount:byte;
		phaseinc:shortint;
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		function tick:PLemming;virtual;
		function testSpace(xx,yy:integer):boolean;virtual;
	end;

type PDigger=^TDigger;
	TDigger=object(TLemming)
		emptyCount:byte;
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		function tick:PLemming;virtual;
		function reincarnate:PLemming; virtual;
	end;


type PBlocker=^TBlocker;
	TBlocker=object(TLemming)
		i:byte;
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		destructor done; virtual;
		function tick:PLemming;virtual;
		function reincarnate:PLemming; virtual;
	end;

type PTunneller=^TTunneller;
	TTunneller=object(TLemming)
		emptyCount:integer;
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		function tick:PLemming;virtual;
		function reincarnate:PLemming; virtual;
	end;

type PBuilder=^TBuilder;
	TBuilder=object(TLemming)
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		destructor done; virtual;
		function tick:PLemming;virtual;
		function reincarnate:PLemming; virtual;
	end;

type PFlyer=^TFlyer;
	TFlyer=object(TLemming)
		constructor init(xx,yy:word; xdir:shortint;lt:longint);
		destructor done; virtual;
		function tick:PLemming;virtual;
		function reincarnate:PLemming; virtual;
	end;
