type Tmouse=object
		rclicks,lclicks,rcx,rcy,lcx,lcy,x,y,maxx,maxy:word;
		left,right:boolean;


		procedure show;
		procedure hide;
		procedure update;
		procedure setxy(xx,yy:word);
		function test:boolean;
	end;
function Tmouse.test;

var vect:^byte absolute 0:$CC;
begin
	test:=false;
	if (vect<>nil) {and (vect^<>$CF)} then begin
		test:=true;
		update;
	end;
end;

procedure Tmouse.show;
begin
	asm
		mov ax,1
		int 33h
	end;
end;
procedure Tmouse.hide;
begin
	asm
		mov ax,2
		int 33h
	end;
end;

procedure Tmouse.update;
var l,r,_x,_y,_lc,_rc,_lcx,_lcy,_rcx,_rcy:word;
begin

	asm
		{read the coordinats and button state}
		mov ax,3
		int 33h
		mov _x,cx
		mov _y,dx
		mov ax,bx
		and ax,1
		mov l, ax
		shr bx,1
		and bx,1
		mov r, bx

		{read the left button press count + coords.}
		mov ax,5
		mov bx,0
		int 33h
		mov _lc,bx
		mov _lcx,cx
		mov _lcy,dx

		{read the right button press count + coords.}
		mov ax,5
		mov bx,0
		int 33h
		mov _rc,bx
		mov _rcx,cx
		mov _rcy,dx
	end;
	left:=boolean(l);
	right:=boolean(r);
	self.x:=longint(_x)*maxx div 640;
	self.y:=longint(_y)*maxy div 200;
	self.lcx:=longint(_lcx)*maxx div 640;
	self.lcy:=longint(_lcy)*maxy div 200;
	self.rcx:=longint(_rcx)*maxx div 640;
	self.rcy:=longint(_rcy)*maxy div 200;



	self.lclicks:=_lc;self.rclicks:=_rc;
end;

procedure Tmouse.setxy(xx,yy:word);
begin
	xx:=longint(xx)*640 div maxx;
	yy:=longint(xx)*200 div maxy;
	asm
		mov ax,4
		mov cx,xx
		mov dx,yy
		int 33h
	end;
end;
